%define srcname lua
%define major 5.2
%define minor 4
%define libname %mklibname %{name}
%define develname %mklibname %{name} -d
%define staticname %mklibname %{name} -d -s
%define alt_priority %(echo %{major} | sed -e 's/[^0-9]//g')

Summary:	Powerful, light-weight programming language
Name:		%{srcname}%{major}
Version:	%{major}.%{minor}
Release:	%mkrel 2
License:	MIT
URL:		http://www.lua.org/
Group:		Development/Other
Source0:	http://www.lua.org/ftp/%{srcname}-%{version}.tar.xz
Source1: lua.pc
Patch0:		lua-5.2.1-dynlib.patch
Patch2:		lua-5.2.0-modules_path.patch
Provides:	lua%{major}
Provides:	lua = %{version}
Obsoletes:	lua = %{major}
BuildRequires: %{_lib}readline-devel
BuildRequires: ncurses-devel
BuildRoot:	%{_tmppath}/%{name}-%{release}-buildroot

%description
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

#german
%description -l de
Lua ist eine mächtige leichtgewichtige Programmiersprache. Lua ist eine 
Programmiersprache die ursprünglich zum Erweitern von Anwendungen entworfen 
wurde, sie wird aber häufig als allgemeine, eigenständige Sprache verwendet. 
LUA kombiniert einfache prozedurale Syntax (vergleichbar mit der Pascal-Schreibweise) 
mit leistungsstarken Daten Beschreibungen, Konstrukte Grundlagen, assoziativen Arrays 
und erweiterbare Semantik. LUA wird dynamisch eingegeben, aus Bytecodes interpretiert 
und hat eine automatische Speicherverwaltung, wodurch sich ideal für Konfigurationen, 
Skripte und schnelle Prototypen eignet. LUA wird als eine kleine Bibliothek von 
C-Funktionen in ANSI C geschrieben sowie kompiliert und unverändert in allen bekannten 
Plattformen implementiert. Die Implementierungsziele sind Einfachheit Effizienz, 
Portabilität und niedrige Kosten mit einander zu verbinden.

%package -n %{libname}
Summary:	Lua is a powerful, light-weight programming language
Group:		System/Libraries

%description -n %{libname}
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package includes the libraries.

#german
%description -n %{libname} -l de
Lua ist eine mächtige leichtgewichtige Programmiersprache. Lua ist eine 
Programmiersprache die ursprünglich zum Erweitern von Anwendungen entworfen 
wurde, sie wird aber häufig als allgemeine, eigenständige Sprache verwendet. 
LUA kombiniert einfache prozedurale Syntax (vergleichbar mit der Pascal-Schreibweise) 
mit leistungsstarken Daten Beschreibungen, Konstrukte Grundlagen, assoziativen Arrays 
und erweiterbare Semantik. LUA wird dynamisch eingegeben, aus Bytecodes interpretiert 
und hat eine automatische Speicherverwaltung, wodurch sich ideal für Konfigurationen, 
Skripte und schnelle Prototypen eignet. LUA wird als eine kleine Bibliothek von 
C-Funktionen in ANSI C geschrieben sowie kompiliert und unverändert in allen bekannten 
Plattformen implementiert. Die Implementierungsziele sind Einfachheit Effizienz, 
Portabilität und niedrige Kosten mit einander zu verbinden.

%package -n %{develname}
Summary:	Headers and development files for Lua
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	lua-devel = %{version}-%{release}
Provides:	lua%{major}-devel = %{version}-%{release}
Provides:	liblua-devel = %{version}-%{release}
Provides:	liblua%{major}-devel = %{version}-%{release}
Obsoletes: 	%{_lib}lua5-devel < %{version}
Obsoletes:	%{_lib}lua4-devel
Obsoletes:	%{libname}-devel

%description -n %{develname}
This package contains the headers and development files for Lua.

#german
%description -n %{develname} -l de
Dieses Paket enthält die Header und Entwicklungsdateien für LUA.

%package -n	%{staticname}
Summary:	Static development files for Lua
Group:		Development/Other
Requires:	%{develname} = %{version}-%{release}
Provides:	lua-static-devel = %{version}-%{release}
Conflicts:	%{libname}-devel-static < %{version}
Conflicts:	%{libname}-static-devel < %{version}
Obsoletes:	%{libname}-static-devel
Obsoletes:	%{libname}-devel-static

%description -n	%{staticname}
This package contains the static development files for Lua.

#german
%description -n	%{staticname} -l de
Dieses Paket enthält die statischen Entwicklungs-Dateien für Lua.
%prep
%setup -qn lua-%{major}.%{minor}
%patch0 -p1 -b .dynlib
%patch2 -p1 -b .modules
mkdir -p etc
cp %{SOURCE1} ./etc/
sed -i -e 's/@MAJOR_VERSION@/%{major}/g' ./etc/lua.pc
sed -i -e 's/@FULL_VERSION@/%{version}/g' ./etc/lua.pc

sed -i -e "s|/usr/local|%{_prefix}|g" Makefile
sed -i -e "s|/lib|/%{_lib}|g" Makefile
sed -i -e "s|/usr/local|%{_prefix}|g" src/luaconf.h
sed -i -e "s|/lib|/%{_lib}|g" src/luaconf.h
sed -i -e "s|/man/man1|/share/man/man1|g" Makefile
sed -i -e "s|\$(V)|%{major}|g" src/Makefile

%build
sed -i 's/-lncurses/-lncursesw/g' */Makefile*
# (tv) enable compat module (fix building rpm with lua-5.2):
%make linux CFLAGS="%{optflags} -fPIC -DLUA_USE_LINUX -DLUA_COMPAT_MODULE"

%install
rm -rf %buildroot
%makeinstall_std INSTALL_TOP=%{buildroot}%{_prefix} INSTALL_LIB=%{buildroot}%{_libdir} INSTALL_MAN=%{buildroot}%{_mandir}/man1
install -d %{buildroot}%{_libdir}/lua/%{major}/
install -d %{buildroot}%{_datadir}/lua/%{major}/

install -m 755 src/liblua.so.%{major}* %{buildroot}%{_libdir}
ln -s liblua.so.%{major} %{buildroot}%{_libdir}/liblua.so

install -d -m 755 %{buildroot}%{_libdir}/pkgconfig/
install -m 644 etc/lua.pc %{buildroot}%{_libdir}/pkgconfig/

# for update-alternatives
mv %{buildroot}%{_bindir}/lua %{buildroot}%{_bindir}/lua%{major}
mv %{buildroot}%{_bindir}/luac %{buildroot}%{_bindir}/luac%{major}

%post
/usr/sbin/update-alternatives --install %{_bindir}/lua lua %{_bindir}/lua%{major} %{alt_priority} --slave %{_bindir}/luac luac %{_bindir}/luac%{major}

%postun
[[ -f %{_bindir}/lua%{major} ]] || /usr/sbin/update-alternatives --remove lua %{_bindir}/lua%{major}

%files
%doc doc/*{.html,.css,.gif,.png}
%doc README
%{_bindir}/*
%{_mandir}/man1/*
%dir %{_datadir}/lua/%{major}

%files -n %{libname}
%{_libdir}/liblua.so.%{major}*
%dir %{_libdir}/lua/%{major}

%files -n %{develname}
%{_includedir}/*
%{_libdir}/pkgconfig/*
%{_libdir}/liblua.so

%files -n %{staticname}
%{_libdir}/*.a


%changelog
* Fri Jul 07 2017 adrianomorselli <adrianomorselli> 5.2.4-2uplos2017
- rebuild for 2017
